#!/usr/bin/perl
# ----- t03.t ---------------------------------------------------
# vim:set syntax=perl:
# almost verbatim copy from the Dazuko::Obj(3) manpage

use strict;

my $loaded = 0;
my $mayblock = 0; # set to 0 to have the test NOT block

BEGIN { $| = 1; print "1..11\n"; }
use Dazuko::Obj;
$loaded = 1;
print "ok 1\n";
END { print "not ok 1\n" unless $loaded; }

my ( $dazuko, $rc, $group, $mode, $mask, );

$dazuko = Dazuko::Obj->new();
print defined $dazuko ? "" : "not ", "ok 2\n";

$group = "Vendor:App"; $mode = "rw";
$rc = $dazuko->Register($group, $mode);
print $rc ? "" : "not ", "ok 3\n";
$mask = $Dazuko::IO::DAZUKO_ON_OPEN | $Dazuko::IO::DAZUKO_ON_CLOSE;
$rc = $dazuko->AccessMask($mask);
print $rc ? "" : "not ", "ok 4\n";
$rc = $dazuko->Include(qw( /home /data ));
print $rc ? "" : "not ", "ok 5\n";
$rc = $dazuko->Exclude(qw( /dev/null /proc ));
print $rc ? "" : "not ", "ok 6\n";

if ($mayblock) {
  while ($dazuko->GetAccess()) {
    print "ok 7\n";
    $dazuko->CheckAccess();
    print "ok 8\n";
    $rc = $dazuko->ReturnAccess();
    print $rc ? "" : "not ", "ok 9\n";
    # to make this not loop in the automatic test scenario
    last;
  }
  print "ok 10\n";
} else {
  # we're not allowed to block the test, fake OK results
  print "ok 7\n";
  print "ok 8\n";
  print "ok 9\n";
  print "ok 10\n";
}

$rc = $dazuko->Unregister();
print $rc ? "" : "not ", "ok 11\n";
$dazuko = undef;

1;

# ----- E O F ---------------------------------------------------
