/*
 * Copyright (C) 2004 Robert Hogan <robert at roberthogan dot net>
 */

#include "klamav.h"
#include "freshklam.h"
#include "klamd.h"
#include "sigtool.h"
#include "klamscan.h"
#include "kuarantine.h"
#include "aboutklamav.h"

#include <qdragobject.h>
#include <kprinter.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>

#include <kglobal.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <kkeydialog.h>
#include <kaccel.h>
#include <kio/netaccess.h>
#include <kfiledialog.h>
#include <kconfig.h>
#include <kurl.h>
#include <kurlrequesterdlg.h>

#include <kedittoolbar.h>

#include <kstdaccel.h>
#include <kaction.h>
#include <kstdaction.h>

#include <qpushbutton.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlistbox.h>
#include <qregexp.h>
#include <qwhatsthis.h>
#include <kbuttonbox.h>
#include <kfiledialog.h>
#include <kprocess.h>
#include <kapplication.h>
#include <kiconloader.h>
#include <kwin.h>
#include <kurlrequester.h>
#include <kurlcompletion.h>
#include <kcombobox.h>
#include <kdebug.h>
#include <qlayout.h>
#include <kcmdlineargs.h>
#include <kmessagebox.h>
#include <ksystemtray.h>
#include <kpopupmenu.h>
#include <qtooltip.h>

Klamav *kmain = 0L;



Klamav::Klamav()
    : KMainWindow( 0, "Klamav" )
{


	kmain = this;
	QVBoxLayout *top = new QVBoxLayout(this,10,10);
	tab = new QTabWidget(this);
	
	
	
	klamscan = new Klamscan(this);
	tab->addTab(klamscan, i18n("&Scan"));
	
	freshklam = new Freshklam(this);
	tab->addTab(freshklam, i18n("&Update"));
	
	sigtool = new Sigtool(this);
	tab->addTab(sigtool, i18n("&E-Mail Protection"));
	
	klamd = new Klamd(this);
	tab->addTab(klamd, i18n("&Auto-Scan"));
	
	kuarantine = new Kuarantine(this);
	tab->addTab(kuarantine, i18n("&Quarantine"));
	
	aboutklamav = new Aboutklamav(this);
	tab->addTab(aboutklamav, i18n("Abou&t"));
	
	connect(klamd->search_button,SIGNAL(clicked()),SLOT(contextEnable()));
	connect(klamd->cancel_button,SIGNAL(clicked()),SLOT(contextDisable()));
  
  	_tray = new KSystemTray(kmain, "klamav tray");
	_tray->setPixmap(KSystemTray::loadIcon("klamavbw"));
	connect(_tray,SIGNAL(quitSelected()),SLOT(shuttingDown()));
	
	KPopupMenu *conf_menu = _tray->contextMenu();
        EnableKlamd = new KAction(i18n("&Enable Auto-Scan"), "klamav", 0,this, SLOT(contextEnable()),actionCollection(),"klamd_enable");
        DisableKlamd = new KAction(i18n("&Disable Auto-Scan"),"klamavbw", 0,this, SLOT(contextDisable()),actionCollection(),"klamd_disable");
        EnableKlamd->plug(conf_menu);
	DisableKlamd->plug(conf_menu);
	QToolTip::add( _tray, "KlamAV - Virus Protection for KDE" );
	_tray->show();


	top->addWidget(tab);
	
	KStdAction::quit(this, SLOT(shuttingDown()), actionCollection());
  
  	if (KApplication::kApplication()->isRestored()){
/*		config = KGlobal::config();
		config->setGroup("Klamd");
		QString RunKlamd = config->readEntry("Enabled");
		
		if (RunKlamd == "Yes"){
			_tray->setPixmap(KSystemTray::loadIcon("klamav"));
			DisableKlamd->setEnabled(TRUE);
			EnableKlamd->setEnabled(FALSE);

		}
*/
		hide();
	}else{
		show();
   	}
	DisableKlamd->setEnabled(FALSE);
	EnableKlamd->setEnabled(TRUE);


}
	
Klamav::~Klamav()
{
}

void  Klamav::shuttingDown(){

	this->topLevelWidget()->hide();

}

bool Klamav::queryClose() {
	if (klamd->isKlamdAlive()){
		hide();
		_tray->setPixmap(KSystemTray::loadIcon("klamav"));
		return false;
	}
	return true;

}


void Klamav::contextEnable() {
	
	klamd->startKlamd();
	//if (klamd->startKlamd()){
			//_tray->setPixmap(KSystemTray::loadIcon("klamav"));
			//EnableKlamd->setEnabled(FALSE);
			//DisableKlamd->setEnabled(TRUE);
	//}
}

void Klamav::contextDisable() {
	klamd->slotCancel();
	_tray->setPixmap(KSystemTray::loadIcon("klamavbw"));
	DisableKlamd->setEnabled(FALSE);
	EnableKlamd->setEnabled(TRUE);
}


#include "klamav.moc"
